View Issue Details

IDProjectCategoryView StatusLast Update
0000752Far ManagerViewerpublic2011-03-22 02:19
ReportertheultramageAssigned Toalexy 
PrioritynormalSeverityminorReproducibilityhave not tried
Status closedResolutionfixed 
Product Version 
Target VersionFixed in Version3.0 
Summary0000752: hex view on utf8 files shows each byte as 0x00
DescriptionWhen viewing an utf8 file, and switching to hex view (F4), all data shows as 00.
Is this the best way to handle this sort of situation?

Example:
0000000000: 00 00 00 00 00 00 │ ?áéíóú

When using shift+F8 to change codepage to ANSI, it displays corectly.
When using F8 to switch between ANSI/OEM, it switches to ascii display and works too.
Additional InformationTo reproduce:
1. create new file with encoding set to UTF-8
2. write something and save
3. view the new file in hex mode (F3, then F4)
TagsNo tags attached.
Build1925

Relationships

has duplicate 0000826 closed Wrong hex values in viewer for text with Hebrew characters 
has duplicate 0000854 closed Hex view shows wrong hex values for the UTF-8 encoded files 

Activities

alexmitin

2009-05-06 09:46

reporter   bugnote:0003118

Перенесено из 0000854

> В общем тут есть такое (цитата):
> "А зачем в Viewer::ShowHex() вызывается вот это:
> WideCharToMultiByte(VM.CodePage, 0, (const wchar_t*)&Ch,1, &NewCh,1," ",NULL);
> после чего печатается 16-ричный код NewCh (который для файлв в utf8
> может принимать любое значение, зависящее от положения луны, погодных
> условий и пр.)"
>
>возможно это и лечение.
>"возможно" - потому, что пока не пойму на что оно может повлиять.
>
> alexmitin: закомменть эту строку и попытайся "исследовать"
> на что оно повлияет :-)

Там проблема глубже. Текущий код viewer расчитан на представление текста в разных кодировках. Но он не очень хорошо расчитан на представление hex вида для кодировок с переменным числом байт/символ.

Сейчас код viewer читает данные из файла, исходя из кодировки заданной пользователем, и конвертирует их в Unicode (UTF-16) - смотри функцию Viewer::vread() - для дальнейшего показа на консоли. Для показа просто текста этого вполне достаточно.

При переключении в hex режим - код в Viewer::ShowHex() пытается конвертировать данные обратно из Unicode в заданную кодировку, и только потом показать байт в виде hex значения.

Тут несколько проблем:

1) Двойное преобразование может привести к потере информации.

2) Не проверяется результат функции WideCharToMultiByte. В случае неудачи значение NewCh не изменяется, а так как это значение и не проинициализировано - то оно содержит просто мусор.

3) Код не расчитан, что один символ может занимать разное число байт - как раз случай UTF-8. Оригинальная спецификация допускала от 1 до 6 байт на символ
(Смотри http://en.wikipedia.org/wiki/UTF-8 ) Позже RFC3629 ограничил допустимый диапазон: каждый символ может занимать от 1 до 4 байт.

Проблема хорошо видна на значениях offset в левой части. Каждая hex строка показываает 16 байт. А вот offset в случае UTF-8 кодировки не соответствует количеству байт. Скорее он показывает количество символов. Но тогда теряется смысл hex режима для UTF-8.
-----------------

Для hex вида нужно читать байты из файла без изменений, показывать оригинальные значения каждого байта, а в правой части показывать текст в выбранной кодировке. Тут есть проблема, что вывод нужно форматировать с учетом позиции символа и его размера в байтах. Вполне может оказаться, что байты символа могут оказаться на разных строках hex вывода. Думаю правильнее показывать символ на позиции первого байта, а остальные места заполнять пробелами или предопределенным символом (это можно сделать конфигурируемым через регистр).

Все это требует значительного изменения кода viewer.

2useven10

2011-03-22 00:26

developer  

viewer.diff (6,101 bytes)
viewer.diff (6,101 bytes)

2useven10

2011-03-22 00:27

developer  

hex-view-far3.PNG (63,530 bytes)
hex-view-far3.PNG (63,530 bytes)

2useven10

2011-03-22 00:28

developer   bugnote:0006540

предлагается вариант hex-view для utf-8

alexy

2011-03-22 00:37

administrator   bugnote:0006541

вроде не плохо. Тока может придумать что то чтоб этот "continue char" как то цветом помечать?

З.Ы. Почем wcscpy(OutStr,L""); а не *OutStr=0;?

2useven10

2011-03-22 00:41

developer   bugnote:0006543

Last edited: 2011-03-22 00:43

View 2 revisions

копипаст из кода для однобайтных кодировок (ниже)...
И тогда уж... = L'\0';
насчет цвета - никогда не делал.
если кто-нибудь сделает, у меня никаких возражений нет :)

alexy

2011-03-22 01:06

administrator   bugnote:0006546

1925

2useven10

2011-03-22 01:29

developer   bugnote:0006547

заметил одну фичу: в far2 при переключении по F4 выделение найденного сохраняется, а в far3 теряется. Наверное правильнее было-бы сохранить поведение far2. Или в far3 'правильное' поведение?

alexy

2011-03-22 02:19

administrator   bugnote:0006548

Fixed in 1925.

А про выделение это уже для другого тикета тема.

Issue History

Date Modified Username Field Change
2009-02-23 13:58 theultramage New Issue
2009-04-15 11:30 alexy Relationship added has duplicate 0000826
2009-05-05 13:11 vskirdin Relationship added has duplicate 0000854
2009-05-06 09:46 alexmitin Note Added: 0003118
2011-03-22 00:26 2useven10 File Added: viewer.diff
2011-03-22 00:27 2useven10 File Added: hex-view-far3.PNG
2011-03-22 00:28 2useven10 Note Added: 0006540
2011-03-22 00:37 alexy Note Added: 0006541
2011-03-22 00:41 2useven10 Note Added: 0006543
2011-03-22 00:43 2useven10 Note Edited: 0006543 View Revisions
2011-03-22 00:51 alexy Assigned To => alexy
2011-03-22 00:51 alexy Status new => assigned
2011-03-22 01:06 alexy Note Added: 0006546
2011-03-22 01:06 alexy Status assigned => feedback
2011-03-22 01:29 2useven10 Note Added: 0006547
2011-03-22 02:19 alexy Build => 1925
2011-03-22 02:19 alexy Note Added: 0006548
2011-03-22 02:19 alexy Status feedback => closed
2011-03-22 02:19 alexy Resolution open => fixed
2011-03-22 02:19 alexy Fixed in Version => 3.0